function loadfile(p) -- string -- function -- reads file *p* and returns a function if possible
 local f = io.open(p,"rb")
 local c = f:read("*a")
 f:close()
 return load(c,p,"t")
end
function runfile(p,...) -- string -- -- runs file *p* with arbitrary arguments in the current thread
 return loadfile(p)(...)
end

_G.package = {}
package.path="/boot/lib/?.lua;/pkg/lib/?.lua;/boot/lib/?/init.lua;/pkg/lib/?/init.lua;./?;./?.lua;./?/init.lua"
package.loaded = {buffer=buffer, component=component, computer=computer, coroutine=coroutine, fs=fs, math=math, os=os, package=package, string=string, table=table}
package.alias = {filesystem="fs"}
function require(f,force) -- string boolean -- table -- searches for a library with name *f* and returns what the library returns, if possible. if *force* is set, loads the library even if it is cached
 f=package.alias[f] or f
 if not package.loaded[f] or force then
  local ln = f:gsub("%.","/")
  for d in package.path:gmatch("[^;]+") do
   local p = d:gsub("%?",ln)
   if fs.exists(p) and not fs.isDirectory(p) then
    package.loaded[f] = runfile(p)
    break
   end
  end
 end
 if package.loaded[f] then
  return package.loaded[f]
 end
 error("library not found: "..f)
end
function reload(f) -- string -- table -- Reloads library *f* from disk into memory.
 return require(f,true)
end
