--#includepkglib "diskpart" "lib/diskpart.lua" "diskpart"
--#includepkglib "rtfs" "lib/fs/rtfs/init.lua" "fs.rtfs"
--#includepkglib "rtfs" "lib/fs/rtfs/v1.lua" "fs.rtfs.v1"
do
 local a = computer.getBootAddress()
 if component.type(a) == "drive" or component.type(a) == "tape_drive" then
  local diskpart = require "diskpart"
  for k,v in ipairs(diskpart.getPartitions(a)) do
   if v[2] == "rtfs" and v[1] == computer.address():sub(1,8) .. "-boot" then
    syslog("Partition with suitable name detected, attempting to mount...")
    local rtfs = require "fs.rtfs"
    fs.makeDirectory("boot")
    local m = rtfs.mount(diskpart.proxyPartition(a,k))
    m.address = string.format("%s/%i/rtfs",a,k)
    fs.mount("boot",m)
    break
   end
  end
 end
end
