local fs = require "filesystem"

local wdir = "/tmp/psbootstrap"
local dlfiles = {
 ["/lib/libmtar.lua"] = "https://git.shadowkat.net/izaya/OC-misc/raw/branch/master/mtar/libmtar.lua",
 ["/lib/fs/rtfs/init.lua"] = "https://git.shadowkat.net/izaya/PsychOSPackages/raw/branch/master/rtfs/lib/fs/rtfs/init.lua", 
 ["/lib/fs/rtfs/v1.lua"] = "https://git.shadowkat.net/izaya/PsychOSPackages/raw/branch/master/rtfs/lib/fs/rtfs/v1.lua", 
 ["/lib/diskpart.lua"] = "https://git.shadowkat.net/izaya/PsychOSPackages/raw/branch/master/diskpart/lib/diskpart.lua", 
 ["/etc/rc.d/partman.lua"] = "https://git.shadowkat.net/izaya/OC-misc/raw/branch/master/partition/OpenOS/etc/rc.d/partman.lua", 
 ["/bin/slicer.lua"] = "https://git.shadowkat.net/izaya/PsychOSPackages/raw/branch/master/slicer/exec/slicer.lua",
 ["/bin/boopu.lua"] = "https://git.shadowkat.net/izaya/PsychOSPackages/raw/branch/master/boopu/exec/boopu.lua",
}

local function run(cmd)
 print(cmd)
 os.execute(cmd)
end

print("Downloading and linking files...")
for k,v in pairs(dlfiles) do
 local tpath = string.format("%s/%s", wdir, k)
 local isdir = fs.isDirectory(fs.path(tpath)) or fs.makeDirectory(fs.path(tpath))
 run(string.format("wget '%s' '%s'", v, tpath))
 local lt = k
 while not fs.isDirectory(fs.path(lt)) and not fs.isLink(fs.path(lt)) do
  lt = fs.path(lt)
 end
 if fs.get(tpath) ~= fs.get(lt) then
  run(string.format("ln '%s/%s' '%s'", wdir, lt, lt))
 end
end
